Index: oln/core/abstract/neighborhood.hh
===================================================================
--- oln/core/abstract/neighborhood.hh	(revision 130)
+++ oln/core/abstract/neighborhood.hh	(working copy)
@@ -28,56 +28,61 @@
 #ifndef OLENA_CORE_NEIGHBORHOOD_HH
 # define OLENA_CORE_NEIGHBORHOOD_HH
 
-# include <mlc/types.hh>
-# include <oln/core/properties.hh>
-# include <oln/core/coord.hh>
-# include <oln/core/abstract/dpoint.hh>
-# include <oln/core/accum.hh>
 # include <vector>
 # include <utility>
 # include <iostream>
 
+# include <oln/core/typedefs.hh>
+# include <oln/core/coord.hh>
+# include <oln/core/abstract/dpoint.hh>
+# include <oln/core/accum.hh>
+
+
+# define oln_nbh_type_of(NeighborhoodType, Alias)  \
+mlc_type_of(oln, oln::category::neighborhood, NeighborhoodType, Alias)
+
+
 namespace oln {
 
-  // fwd decl
-  namespace abstract {
-    template<class Exact>
+  namespace category
+  {
     struct neighborhood;
   }
 
-  // category
-  template <typename E>
-  struct set_category< abstract::neighborhood<E> >
+  /// Default properties of any neighborhood type.
+
+  template <>
+  struct set_default_props < category::neighborhood >
   {
-    typedef category::neighborhood ret;
+    typedef mlc::undefined_type dpoint_type;
+    typedef mlc::undefined_type size_type;
+    typedef mlc::undefined_type window_type;
   };
 
-  /// properties of any type in category::neighborhood
 
-  template <typename type>
-  struct props_of <category::neighborhood, type>
+  /// Retrieval of any image type properties (FIXME: say 'packing').
+
+  template <typename N>
+  struct get_props < category::neighborhood, N >
   {
-    typedef mlc::true_type user_defined_;
+    typedef oln_nbh_type_of(N, dpoint) dpoint_type;
+    typedef oln_nbh_type_of(N, size)   size_type;
+    typedef oln_nbh_type_of(N, window) window_type;
 
-    mlc_decl_prop(category::neighborhood, dpoint_type);
-    mlc_decl_prop(category::neighborhood, size_type);
-    mlc_decl_prop(category::neighborhood, window_type);
-
     static void echo(std::ostream& ostr)
     {
-      ostr << "props_of( category::neighborhood, "
-	   << typeid(type).name() << ") = {"
-	   << "  size_type = " << typeid(size_type).name() << "," << std::endl
-	   << "  dpoint_type = " << typeid(dpoint_type).name() << "  }" << std::endl;
+      ostr << "props_of( oln::category::neighborhood, " << mlc_to_string(N) << " ) =" << std::endl
+	   << "\t dpoint_type = " << mlc_to_string(dpoint_type) << std::endl
+	   << "\t size_type   = " << mlc_to_string(size_type)   << std::endl
+	   << "\t window_type = " << mlc_to_string(window_type) << std::endl
+	   << std::endl;
     }
 
   };
 
-  mlc_register_prop(category::neighborhood, dpoint_type);
-  mlc_register_prop(category::neighborhood, size_type);
-  mlc_register_prop(category::neighborhood, window_type);
 
 
+
   namespace abstract {
 
     /*!
@@ -92,7 +97,7 @@
 
     public:
 
-      typedef oln_type_of(E, dpoint) dpoint_type;
+      typedef oln_nbh_type_of(E, dpoint) dpoint_type;
 
       typedef E exact_type;
 
Index: oln/core/abstract/image_by_delegation.hh
===================================================================
--- oln/core/abstract/image_by_delegation.hh	(revision 130)
+++ oln/core/abstract/image_by_delegation.hh	(working copy)
@@ -29,8 +29,7 @@
 # define OLENA_CORE_ABSTRACT_IMAGE_BY_DELEGATION_HH
 
 # include <oln/core/box.hh>
-# include <oln/core/properties.hh>
-# include <oln/core/abstract/entry.hh>
+# include <oln/core/abstract/image_entry.hh>
 
 
 namespace oln {
@@ -41,17 +40,12 @@
     template <typename I, typename E> struct image_by_delegation;
   }
 
-  // category
+  // super type
 
   template <typename I, typename E>
-  struct set_category< abstract::image_by_delegation<I, E> > {
-    typedef category::image ret;
-  };
-
+  struct set_super_type < abstract::image_by_delegation<      I, E> > { typedef abstract::image_entry<E> ret; };
   template <typename I, typename E>
-  struct set_category< abstract::image_by_delegation<const I, E> > {
-    typedef category::image ret;
-  };
+  struct set_super_type < abstract::image_by_delegation<const I, E> > { typedef abstract::image_entry<E> ret; };
 
   // props
 
Index: oln/core/abstract/image_with_extension.hh
===================================================================
--- oln/core/abstract/image_with_extension.hh	(revision 130)
+++ oln/core/abstract/image_with_extension.hh	(working copy)
@@ -25,8 +25,8 @@
 // reasons why the executable file might be covered by the GNU General
 // Public License.
 
-#ifndef OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION__HH
-# define OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION__HH
+#ifndef OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION_HH
+# define OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION_HH
 
 # include <oln/core/abstract/image_by_delegation.hh>
 
@@ -36,28 +36,18 @@
 
   // fwd decl
   namespace abstract {
-    template <typename I, typename E> struct image_with_extension_;
+    template <typename I, typename E> struct image_with_extension;
   }
 
-  // category
-
-  template <typename I, typename E>
-  struct set_category< abstract::image_with_extension_<I, E> > {
-    typedef category::image ret;
-  };
-
   // super type
 
   template <typename I, typename E>
-  struct set_super_type < abstract::image_with_extension_<I, E> >
-  {
-    typedef abstract::image_by_delegation<I, E> ret;
-  };
+  struct set_super_type < abstract::image_with_extension<I, E> > { typedef abstract::image_by_delegation<I, E> ret; };
 
   // props
 
   template <typename I, typename E>
-  struct set_props < category::image, abstract::image_with_extension_<I, E> > : public props_of<category::image>
+  struct set_props < category::image, abstract::image_with_extension<I, E> >
   {
     typedef oln_type_of(I, concrete) concrete_type;
   };
@@ -65,20 +55,20 @@
 
   namespace abstract {
 
-    /// Mutable version of image_with_extension_.
+    /// Mutable version of image_with_extension.
 
     template <typename I, typename E>
-    struct image_with_extension_ : public image_by_delegation<I, E>
+    struct image_with_extension : public image_by_delegation<I, E>
     {
       typedef image_by_delegation<I, E> super_type;
 
     public:
 
-      image_with_extension_ ()
+      image_with_extension ()
       {
       }
 
-      image_with_extension_(abstract::image<I>& image) :
+      image_with_extension(const abstract::image<I>& image) :
 	super_type(image)
       {
       }
@@ -93,7 +83,7 @@
 	return this->image_.unbox();
       }
 
-      ~image_with_extension_ ()
+      ~image_with_extension ()
       {
 	// FIXME : This class must check all properties
 
@@ -115,4 +105,4 @@
 } // end of namespace oln
 
 
-#endif // ! OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION__HH
+#endif // ! OLENA_CORE_ABSTRACT_IMAGE_WITH_EXTENSION_HH
Index: oln/core/abstract/size.hh
===================================================================
--- oln/core/abstract/size.hh	(revision 130)
+++ oln/core/abstract/size.hh	(working copy)
@@ -31,6 +31,7 @@
 # include <mlc/any.hh>
 # include <mlc/if.hh>
 # include <mlc/cmp.hh>
+# include <oln/core/typedefs.hh>
 
 
 // fwd decl
Index: oln/core/abstract/internal/image_impl.hh
===================================================================
--- oln/core/abstract/internal/image_impl.hh	(revision 130)
+++ oln/core/abstract/internal/image_impl.hh	(working copy)
@@ -31,9 +31,7 @@
 # include <mlc/any.hh>
 # include <mlc/types.hh>
 
-# include <oln/core/properties.hh>
 
-
 namespace oln {
 
   namespace abstract {
Index: oln/core/1d/dpoint1d.hh
===================================================================
--- oln/core/1d/dpoint1d.hh	(revision 130)
+++ oln/core/1d/dpoint1d.hh	(working copy)
@@ -28,15 +28,23 @@
 #ifndef OLENA_CORE_1D_DPOINT1D_HH
 # define OLENA_CORE_1D_DPOINT1D_HH
 
-# include <ostream>
+# include <iostream>
+
 # include <oln/core/coord.hh>
 # include <oln/core/abstract/dpoint.hh>
 
 
 namespace oln {
 
+  // fwd decls
+  struct dpoint1d;
   struct point1d;
 
+  // super type
+  template <>
+  struct set_super_type < dpoint1d > { typedef abstract::dpoint< dpoint1d > ret; };
+
+
   struct dpoint1d : public abstract::dpoint < dpoint1d >
   {
     dpoint1d()
Index: oln/core/1d/array1d.hh
===================================================================
--- oln/core/1d/array1d.hh	(revision 130)
+++ oln/core/1d/array1d.hh	(working copy)
@@ -28,28 +28,23 @@
 #ifndef OLENA_CORE_1D_ARRAY1D_HH
 # define OLENA_CORE_1D_ARRAY1D_HH
 
-
 # include <oln/core/abstract/data_storage.hh>
 # include <oln/core/1d/size1d.hh>
 # include <oln/core/1d/point1d.hh>
 
+
 namespace oln {
 
-
   // fwd decl
   template <typename T> struct array1d;
 
-  // category
-  template <typename T> 
-  struct set_category< array1d<T> > { typedef category::data_storage ret; };
-
-  // super_type
-  template <typename T> 
-  struct set_super_type< array1d<T> > { typedef abstract::data_storage< array1d<T> > ret; };
+  // super type
+  template <typename T>
+  struct set_super_type < array1d<T> > { typedef abstract::data_storage< array1d<T> > ret; };
   
   // props
   template <typename T>
-  struct set_props < category::data_storage, array1d<T> > : public props_of<category::data_storage>
+  struct set_props < category::data_storage, array1d<T> >
   {
     typedef size1d  size_type;
     typedef point1d point_type;
@@ -57,6 +52,7 @@
   };
 
 
+
   template <typename T>
   class array1d : public abstract::data_storage< array1d<T> >
   {
Index: oln/core/1d/image1d.hh
===================================================================
--- oln/core/1d/image1d.hh	(revision 130)
+++ oln/core/1d/image1d.hh	(working copy)
@@ -28,10 +28,7 @@
 #ifndef OLENA_CORE_1D_IMAGE1D_HH
 # define OLENA_CORE_1D_IMAGE1D_HH
 
-# include <mlc/traits.hh>
-
 # include <oln/core/abstract/image_with_data.hh>
-# include <oln/core/abstract/image_like_.hh>
 # include <oln/core/1d/array1d.hh>
 
 
@@ -42,26 +39,18 @@
 namespace oln {
 
 
-
   // fwd decls
   struct fwd_piter1d;
   template <typename T> class image1d;
 
-  // category
+  // super type
   template <typename T>
-  struct set_category< image1d<T> > { typedef category::image ret; };
+  struct set_super_type < image1d<T> > { typedef abstract::image_with_data< image1d<T> > ret; };
 
-  // super
+  // props
   template <typename T>
-  struct set_super_type < image1d<T> >
+  struct set_props < category::image, image1d<T> >
   {
-    typedef abstract::image_with_data< image1d<T> > ret;
-  };
-
-
-  template <typename T>
-  struct set_props < category::image, image1d<T> > : public props_of<category::image>
-  {
     // intrusive property:
     typedef is_a<abstract::image1d> image_dimension_type;
     // FIXME: should be generalized
@@ -78,7 +67,7 @@
     // please note that value_storage_type means data_type
     // since image1d is an image_with_data
     typedef T value_storage_type;
-//     typedef mlc_encoding_type(T) value_storage_type;
+    // FIXME: above, that should be mlc_encoding_type(T)
 
     // please note that value_container_type means
     // data_container_type (or value_storage_container_type)
Index: oln/core/1d/fwd_piter1d.hh
===================================================================
--- oln/core/1d/fwd_piter1d.hh	(revision 130)
+++ oln/core/1d/fwd_piter1d.hh	(working copy)
@@ -29,7 +29,6 @@
 # define OLENA_CORE_1D_FWD_PITER1D_HH
 
 # include <mlc/contract.hh>
-
 # include <oln/core/abstract/piter.hh>
 # include <oln/core/1d/point1d.hh>
 # include <oln/core/1d/size1d.hh>
@@ -41,14 +40,13 @@
   // fwd decl
   struct fwd_piter1d;
 
-  // category
+  // super type
   template <>
-  struct set_category<fwd_piter1d> { typedef category::piter ret; };
+  struct set_super_type < fwd_piter1d > { typedef abstract::piter< fwd_piter1d > ret; };
 
-
   // props
   template <>
-  struct set_props < category::piter, fwd_piter1d > : public props_of<category::piter>
+  struct set_props < category::piter, fwd_piter1d >
   {
     typedef point1d point_type;
     typedef size1d  size_type;
@@ -64,14 +62,12 @@
     fwd_piter1d(const size1d& size) :
       super_type(size)
     {
-      this->exact_ptr = this;
       this->invalidate();
     }
 
-# if defined __GNUC__ && __GNUC__ >= 3
     friend class abstract::piter< fwd_piter1d >;
+
   protected:
-# endif
 
     void impl_start()
     {
Index: oln/core/1d/point1d.hh
===================================================================
--- oln/core/1d/point1d.hh	(revision 130)
+++ oln/core/1d/point1d.hh	(working copy)
@@ -28,33 +28,25 @@
 #ifndef OLENA_CORE_1D_POINT1D_HH
 # define OLENA_CORE_1D_POINT1D_HH
 
-# include <ostream>
-
+# include <iostream>
 # include <oln/core/abstract/point.hh>
 # include <oln/core/coord.hh>
-# include <oln/core/properties.hh>
 
-// FIXME: doc
 
-// FIXME: test that coords are defined
 
 namespace oln {
 
-
+  // fwd decls
   struct point1d;
   struct dpoint1d;
 
-  // category
+  // super type
   template <>
-  struct set_category< point1d > { typedef category::point ret; };
+  struct set_super_type < point1d > { typedef abstract::point< point1d > ret; };
 
-  // super_type
-  template <>
-  struct set_super_type< point1d > { typedef abstract::point< point1d > ret; };
-
   // props
   template <>
-  struct set_props < category::point, point1d > : public props_of<category::point>
+  struct set_props < category::point, point1d >
   {
     typedef dpoint1d dpoint_type;
   };
@@ -89,10 +81,9 @@
     const coord_t index() const { return index_; }
     coord_t& index() { return index_; }
 
-# if defined __GNUC__ && __GNUC__ >= 3
     friend class abstract::point< point1d >;
+
   protected:
-# endif
 
     const point1d impl_plus(const dpoint1d& rhs) const;
 
Index: oln/core/1d/size1d.hh
===================================================================
--- oln/core/1d/size1d.hh	(revision 130)
+++ oln/core/1d/size1d.hh	(working copy)
@@ -35,7 +35,14 @@
 
 namespace oln {
 
+  // fwd decl
+  struct size1d;
 
+  // super type
+  template <>
+  struct set_super_type < size1d > { typedef abstract::size< size1d > ret; };
+
+
   struct size1d : public abstract::size< size1d >
   {
     size1d()
Index: oln/core/2d/dpoint2d.hh
===================================================================
--- oln/core/2d/dpoint2d.hh	(revision 130)
+++ oln/core/2d/dpoint2d.hh	(working copy)
@@ -35,8 +35,15 @@
 
 namespace oln {
 
+  // fwd decls
+  struct dpoint2d;
   struct point2d;
 
+  // super type
+  template <>
+  struct set_super_type < dpoint2d > { typedef abstract::dpoint< dpoint2d > ret; };
+
+
   struct dpoint2d : public abstract::dpoint < dpoint2d >
   {
     dpoint2d()
Index: oln/core/2d/array2d.hh
===================================================================
--- oln/core/2d/array2d.hh	(revision 130)
+++ oln/core/2d/array2d.hh	(working copy)
@@ -38,17 +38,9 @@
   // fwd decl
   template <typename T> struct array2d;
 
-  // category
-  template <typename T>
-  struct set_category< array2d<T> > { typedef category::data_storage ret; };
-
-  // super_type
-  template <typename T>
-  struct set_super_type< array2d<T> > { typedef abstract::data_storage< array2d<T> > ret; };
-
   // props
   template <typename T>
-  struct set_props < category::data_storage, array2d<T> > : public props_of<category::data_storage>
+  struct set_props < category::data_storage, array2d<T> >
   {
     typedef size2d  size_type;
     typedef point2d point_type;
Index: oln/core/2d/image2d.hh
===================================================================
--- oln/core/2d/image2d.hh	(revision 130)
+++ oln/core/2d/image2d.hh	(working copy)
@@ -28,8 +28,6 @@
 #ifndef OLENA_CORE_IMAGE2D_HH
 # define OLENA_CORE_IMAGE2D_HH
 
-# include <mlc/traits.hh>
-
 # include <oln/core/abstract/image_with_data.hh>
 # include <oln/core/abstract/image_like_.hh>
 # include <oln/core/2d/array2d.hh>
@@ -55,20 +53,13 @@
   struct bkd_piter2d;
   template <typename T> class image2d;
 
-  // category
-  template <typename T>
-  struct set_category< image2d<T> > { typedef category::image ret; };
-
   // super
   template <typename T>
-  struct set_super_type < image2d<T> >
-  {
-    typedef abstract::image_with_data< image2d<T> > ret;
-  };
+  struct set_super_type < image2d<T> > { typedef abstract::image_with_data< image2d<T> > ret; };
 
-
+  // props
   template <typename T>
-  struct set_props < category::image, image2d<T> > : public props_of<category::image>
+  struct set_props < category::image, image2d<T> >
   {
     // intrusive property:
     typedef is_a<abstract::image2d> image_dimension_type;
Index: oln/core/2d/fwd_regular_niter2d.hh
===================================================================
--- oln/core/2d/fwd_regular_niter2d.hh	(revision 130)
+++ oln/core/2d/fwd_regular_niter2d.hh	(working copy)
@@ -38,7 +38,6 @@
 # include <oln/core/gen/image_with_nbh.hh>
 # include <oln/core/abstract/point.hh>
 # include <oln/core/abstract/dpoint.hh>
-# include <oln/core/properties.hh>
 # include <oln/core/abstract/image.hh>
 # include <oln/core/abstract/neighborhood.hh>
 # include <oln/core/abstract/image_neighbness.hh>
Index: oln/core/2d/bkd_piter2d.hh
===================================================================
--- oln/core/2d/bkd_piter2d.hh	(revision 130)
+++ oln/core/2d/bkd_piter2d.hh	(working copy)
@@ -29,7 +29,6 @@
 # define OLENA_CORE_2D_BKD_PITER2D_HH
 
 # include <mlc/contract.hh>
-
 # include <oln/core/abstract/piter.hh>
 # include <oln/core/2d/point2d.hh>
 # include <oln/core/2d/size2d.hh>
@@ -40,14 +39,13 @@
   // fwd decl
   struct bkd_piter2d;
 
-  // category
+  // super type
   template <>
-  struct set_category<bkd_piter2d> { typedef category::piter ret; };
+  struct set_super_type < bkd_piter2d > { typedef abstract::piter< bkd_piter2d > ret; };
 
-
   // props
   template <>
-  struct set_props < category::piter, bkd_piter2d > : public props_of<category::piter>
+  struct set_props < category::piter, bkd_piter2d >
   {
     typedef point2d point_type;
     typedef size2d  size_type;
@@ -58,19 +56,17 @@
   struct bkd_piter2d : public abstract::piter< bkd_piter2d >
   {
 
-    typedef abstract::piter<bkd_piter2d> super_type;
+    typedef abstract::piter< bkd_piter2d > super_type;
 
     bkd_piter2d(const size2d& size) :
       super_type(size)
     {
-      this->exact_ptr = this;
       this->invalidate();
     }
 
-# if defined __GNUC__ && __GNUC__ >= 3
-    friend class abstract::piter< bkd_piter2d >;
+    friend class abstract::piter< bkd_piter2d >; // FIXME: replace by super_type (?)
+
   protected:
-# endif
 
     void impl_start()
     {
Index: oln/core/2d/fwd_piter2d.hh
===================================================================
--- oln/core/2d/fwd_piter2d.hh	(revision 130)
+++ oln/core/2d/fwd_piter2d.hh	(working copy)
@@ -29,7 +29,6 @@
 # define OLENA_CORE_2D_FWD_PITER2D_HH
 
 # include <mlc/contract.hh>
-
 # include <oln/core/abstract/piter.hh>
 # include <oln/core/2d/point2d.hh>
 # include <oln/core/2d/size2d.hh>
@@ -40,14 +39,13 @@
   // fwd decl
   struct fwd_piter2d;
 
-  // category
+  // super type
   template <>
-  struct set_category<fwd_piter2d> { typedef category::piter ret; };
+  struct set_super_type < fwd_piter2d > { typedef abstract::piter< fwd_piter2d > ret; };
 
-
   // props
   template <>
-  struct set_props < category::piter, fwd_piter2d > : public props_of<category::piter>
+  struct set_props < category::piter, fwd_piter2d >
   {
     typedef point2d point_type;
     typedef size2d  size_type;
@@ -63,14 +61,12 @@
     fwd_piter2d(const size2d& size) :
       super_type(size)
     {
-      this->exact_ptr = this;
       this->invalidate();
     }
 
-# if defined __GNUC__ && __GNUC__ >= 3
     friend class abstract::piter< fwd_piter2d >;
+
   protected:
-# endif
 
     void impl_start()
     {
Index: oln/core/2d/fwd_qiter2d.hh
===================================================================
--- oln/core/2d/fwd_qiter2d.hh	(revision 0)
+++ oln/core/2d/fwd_qiter2d.hh	(revision 0)
@@ -0,0 +1,105 @@
+// Copyright (C) 2001, 2003, 2005  EPITA Research and Development Laboratory
+//
+// This file is part of the Olena Library.  This library is free
+// software; you can redistribute it and/or modify it under the terms
+// of the GNU General Public License version 2 as published by the
+// Free Software Foundation.
+//
+// This library is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+// General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with this library; see the file COPYING.  If not, write to
+// the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
+// MA 02111-1307, USA.
+//
+// As a special exception, you may use this file as part of a free
+// software library without restriction.  Specifically, if other files
+// instantiate templates or use macros or inline functions from this
+// file, or you compile this file and link it with other files to
+// produce an executable, this file does not by itself cause the
+// resulting executable to be covered by the GNU General Public
+// License.  This exception does not however invalidate any other
+// reasons why the executable file might be covered by the GNU General
+// Public License.
+
+#ifndef OLENA_CORE_FWD_QITER2D_HH
+# define OLENA_CORE_FWD_QITER2D_HH
+
+# include <string>
+
+# include <oln/core/abstract/qiter.hh>
+# include <oln/core/2d/dpoint2d.hh>
+# include <oln/core/2d/window2d.hh>
+
+
+namespace oln {
+
+  // fwd decl
+  struct fwd_qiter2d;
+
+  // category
+  template <>
+  struct set_super_type< fwd_qiter2d > { typedef abstract::qiter< fwd_qiter2d > ret; };
+
+  // props
+  template <>
+  struct set_props < category::qiter, fwd_qiter2d >
+  {
+    typedef dpoint2d dpoint_type; // FIXME: !!!
+    typedef window2d window_type; // FIXME: !!!
+  };
+
+
+  struct fwd_qiter2d : public abstract::qiter< fwd_qiter2d >
+  {
+    typedef abstract::qiter<fwd_qiter2d> super_type;
+
+    fwd_qiter2d(const window2d& se) :
+      se_(se),
+      pos_(0)
+    {
+      this->invalidate();
+    }
+
+    coord_t impl_nth(unsigned i)
+    {
+      return se_[pos_].nth(i);
+    }
+
+    dpoint2d impl_cast_dpoint() const
+    {
+      precondition(this->is_valid());
+      return se_[pos_];
+    }
+
+    void impl_start()
+    {
+      pos_ = 0;
+    }
+
+    void impl_next()
+    {
+      ++pos_;
+    }
+
+    bool impl_is_valid() const
+    {
+      return pos_ != se_.card();
+    }
+
+    void impl_invalidate()
+    {
+      pos_ = se_.card();
+    }
+
+    const window2d& se_;
+    unsigned pos_;
+
+  };
+
+} // end of namespace oln
+
+#endif // OLENA_CORE_FWD_QITER2D_HH
Index: oln/core/2d/neighborhood2d.hh
===================================================================
--- oln/core/2d/neighborhood2d.hh	(revision 130)
+++ oln/core/2d/neighborhood2d.hh	(working copy)
@@ -28,70 +28,68 @@
 #ifndef OLENA_CORE_NEIGHBORHOOD2D_HH
 # define OLENA_CORE_NEIGHBORHOOD2D_HH
 
+# include <oln/core/coord.hh>
+# include <oln/core/abstract/neighborhood.hh>
 # include <oln/core/2d/dpoint2d.hh>
 # include <oln/core/2d/size2d.hh>
 # include <oln/core/2d/window2d.hh>
-# include <oln/core/coord.hh>
-# include <oln/core/abstract/neighborhood.hh>
 
+
 namespace oln {
 
   class neighborhood2d; // forward declaration
 
-  // category
-  template <>
-  struct set_category< neighborhood2d >
-  { typedef category::neighborhood ret; };
-
   // super_type
   template <>
-  struct set_super_type< neighborhood2d >
-  {
-    typedef abstract::neighborhood< neighborhood2d > ret;
-  };
+  struct set_super_type< neighborhood2d > { typedef abstract::neighborhood< neighborhood2d > ret; };
 
   template <>
   struct set_props< category::neighborhood, neighborhood2d >
-  : public props_of<category::neighborhood>
   {
-    typedef dpoint2d    dpoint_type;
-    typedef size2d      size_type;
-    typedef window2d    window_type;
+    typedef dpoint2d dpoint_type;
+    typedef size2d   size_type;
+    typedef window2d window_type;
   };
 
-  class neighborhood2d : public abstract::neighborhood<neighborhood2d>
+
+  class neighborhood2d : public abstract::neighborhood< neighborhood2d >
   {
 
   public:
 
-    typedef abstract::neighborhood<neighborhood2d>      super_type;
+    typedef abstract::neighborhood< neighborhood2d > super_type;
 
     /*!
     ** \brief Construct a neighborhood of 2 dimensions.
     */
-    neighborhood2d() : super_type()
-    {}
+    neighborhood2d() :
+      super_type()
+    {
+    }
 
     /*!
     ** \brief Construct a neighborhood of 2 dimensions.
     ** \arg size The number of element.
     */
-    neighborhood2d(unsigned size) : super_type(size)
-    {}
+    neighborhood2d(unsigned size) :
+      super_type(size)
+    {
+    }
 
     /*!
     ** \brief Construct a neighborhood of 2 dimensions from several points.
     ** \arg n The number of element.
     ** \arg crd The coordinates of the elements
     */
-    neighborhood2d(unsigned n, const coord_t crd[]) : super_type(n)
+    neighborhood2d(unsigned n, const coord_t crd[]) :
+      super_type(n)
     {
       for (unsigned i = 0; i < 2 * n; i += 2)
-        this->add(dpoint_type(crd[i], crd[i+1]));
+        this->add(dpoint2d(crd[i], crd[i+1]));
     }
 
     neighborhood2d&
-    add(const dpoint_type& dp)
+    add(const dpoint2d& dp)
     {
       return this->exact().impl_add(dp);
     }
@@ -99,7 +97,7 @@
     neighborhood2d&
     add(coord_t row, coord_t col)
     {
-      dpoint_type dp(row, col);
+      dpoint2d dp(row, col);
       return add(dp);
     }
 
@@ -112,7 +110,7 @@
     }
 
     coord_t
-    impl_delta_update(const dpoint_type& dp)
+    impl_delta_update(const dpoint2d& dp)
     {
       delta_(abs(dp.row()));
       delta_(abs(dp.col()));
@@ -121,6 +119,7 @@
 
   };
 
+
   inline const neighborhood2d&
   neighb_c4()
   {
Index: oln/core/2d/window2d.hh
===================================================================
--- oln/core/2d/window2d.hh	(revision 130)
+++ oln/core/2d/window2d.hh	(working copy)
@@ -28,42 +28,37 @@
 #ifndef OLENA_CORE_WINDOW2D_HH
 # define OLENA_CORE_WINDOW2D_HH
 
+# include <oln/core/abstract/window.hh>
 # include <oln/core/2d/dpoint2d.hh>
 # include <oln/core/2d/size2d.hh>
 # include <oln/core/coord.hh>
-# include <oln/core/abstract/struct_elt.hh>
 
+
 namespace oln {
 
-  class window2d; // forward declaration
-  class fwd_witer2d;
+  // fwd decls
+  class window2d;
+  class fwd_qiter2d;
 
-  // category
-  template <>
-  struct set_category< window2d > { typedef category::struct_elt ret; };
-
   // super_type
-  template <>
-  struct set_super_type< window2d >
-  {
-    typedef abstract::struct_elt< window2d > ret;
-  };
+  template <> struct set_super_type< window2d > { typedef abstract::window< window2d > ret; };
 
+  // props
   template <>
-  struct set_props< category::struct_elt, window2d > 
-  : public props_of<category::struct_elt>
+  struct set_props< category::window, window2d > 
   {
     typedef dpoint2d    dpoint_type;
     typedef size2d      size_type;
-    typedef fwd_witer2d fwd_witer_type;
+    typedef fwd_qiter2d fwd_qiter_type;
   };
 
-  class window2d : public abstract::struct_elt<window2d>
+
+  class window2d : public abstract::window< window2d >
   {
 
   public:
    
-    typedef abstract::struct_elt<window2d>      super_type;
+    typedef abstract::window< window2d > super_type;
 
     /*!
     ** \brief Construct a window of 2 dimensions.
Index: oln/core/2d/point2d.hh
===================================================================
--- oln/core/2d/point2d.hh	(revision 130)
+++ oln/core/2d/point2d.hh	(working copy)
@@ -30,7 +30,6 @@
 
 # include <iostream>
 
-# include <oln/core/properties.hh>
 # include <oln/core/abstract/point.hh>
 # include <oln/core/coord.hh>
 
@@ -39,20 +38,17 @@
 
 namespace oln {
 
+  // fwd decls
   struct point2d;
   struct dpoint2d;
 
-  // category
+  // super type
   template <>
-  struct set_category< point2d > { typedef category::point ret; };
+  struct set_super_type < point2d > { typedef abstract::point< point2d > ret; };
 
-  // super_type
-  template <>
-  struct set_super_type< point2d > { typedef abstract::point< point2d > ret; };
-
   // props
   template <>
-  struct set_props < category::point, point2d > : public props_of<category::point>
+  struct set_props < category::point, point2d >
   {
     typedef dpoint2d dpoint_type;
   };
@@ -93,10 +89,9 @@
     coord_t& row() { return row_; }
     coord_t& col() { return col_; }
 
-# if defined __GNUC__ && __GNUC__ >= 3
     friend class abstract::point< point2d >;
+
   protected:
-# endif
 
     const point2d impl_plus(const dpoint2d& rhs) const;
 
Index: oln/core/2d/size2d.hh
===================================================================
--- oln/core/2d/size2d.hh	(revision 130)
+++ oln/core/2d/size2d.hh	(working copy)
@@ -35,7 +35,15 @@
 
 namespace oln {
 
+  // fwd decl
+  struct size2d;
 
+  // super type
+  template <>
+  struct set_super_type < size2d > { typedef abstract::size< size2d > ret; };
+
+
+
   struct size2d : public abstract::size< size2d >
   {
     size2d()
Index: oln/core/3d/array3d.hh
===================================================================
--- oln/core/3d/array3d.hh	(revision 130)
+++ oln/core/3d/array3d.hh	(working copy)
@@ -39,17 +39,13 @@
   // fwd decl
   template <typename T> struct array3d;
 
-  // category
-  template <typename T> 
-  struct set_category< array3d<T> > { typedef category::data_storage ret; };
-
   // super_type
   template <typename T> 
   struct set_super_type< array3d<T> > { typedef abstract::data_storage< array3d<T> > ret; };
   
   // props
   template <typename T>
-  struct set_props < category::data_storage, array3d<T> > : public props_of<category::data_storage>
+  struct set_props < category::data_storage, array3d<T> >
   {
     typedef size3d  size_type;
     typedef point3d point_type;
Index: oln/core/3d/image3d.hh
===================================================================
--- oln/core/3d/image3d.hh	(revision 130)
+++ oln/core/3d/image3d.hh	(working copy)
@@ -46,20 +46,13 @@
   struct fwd_piter3d;
   template <typename T> class image3d;
 
-  // category
-  template <typename T>
-  struct set_category< image3d<T> > { typedef category::image ret; };
-
   // super
   template <typename T>
-  struct set_super_type < image3d<T> >
-  {
-    typedef abstract::image_with_data< image3d<T> > ret;
-  };
+  struct set_super_type < image3d<T> > { typedef abstract::image_with_data< image3d<T> > ret; };
 
 
   template <typename T>
-  struct set_props < category::image, image3d<T> > : public props_of<category::image>
+  struct set_props < category::image, image3d<T> >
   {
     // intrusive property:
     typedef is_a<abstract::image3d> image_dimension_type;
Index: oln/core/3d/fwd_piter3d.hh
===================================================================
--- oln/core/3d/fwd_piter3d.hh	(revision 130)
+++ oln/core/3d/fwd_piter3d.hh	(working copy)
@@ -40,14 +40,9 @@
   // fwd decl
   struct fwd_piter3d;
 
-  // category
-  template <>
-  struct set_category<fwd_piter3d> { typedef category::piter ret; };
-
-
   // props
   template <>
-  struct set_props < category::piter, fwd_piter3d > : public props_of<category::piter>
+  struct set_props < category::piter, fwd_piter3d >
   {
     typedef point3d point_type;
     typedef size3d  size_type;
@@ -58,19 +53,17 @@
   struct fwd_piter3d : public abstract::piter< fwd_piter3d >
   {
 
-    typedef abstract::piter<fwd_piter3d> super_type;
+    typedef abstract::piter< fwd_piter3d > super_type;
 
     fwd_piter3d(const size3d& size) :
       super_type(size)
     {
-      this->exact_ptr = this;
       this->invalidate();
     }
 
-# if defined __GNUC__ && __GNUC__ >= 3
     friend class abstract::piter< fwd_piter3d >;
+
   protected:
-# endif
 
     void impl_start()
     {
